﻿Imports System.Data
Imports System.Data.OleDb
Imports System.Data.SqlClient

' You are granted permission to use this code in full or in part,
' if you keep the following lines in the code files:

' Original code from the Library of:
' Nannette Thacker, http://www.shiningstar.net
' Original ZIP file available for download from: 
' http://weblogs.asp.net/blogs/nannettethacker/zips/ShiningStarVBExcel.zip
' or
' http://aspnet.4guysfromrolla.com/code/NannetteExcelDAL.zip
' Articles on how to use this project:
' http://www.shiningstar.net/Blog/ExcelImportToDatabase.aspx
' http://www.shiningstar.net/ASPNet_Articles/DataSet/DataSetProject.aspx



Partial Class _Default
    Inherits System.Web.UI.Page

    Protected Sub ButtonUpload_Click(ByVal sender As Object, ByVal e As System.EventArgs) _
        Handles ButtonUpload.Click
        PanelUpload.Visible = True
        PanelView.Visible = False
        PanelImport.Visible = False
    End Sub


    Protected Function ExcelConnection() As OleDbCommand

        ' Connect to the Excel Spreadsheet
        Dim xConnStr As String = "Provider=Microsoft.Jet.OLEDB.4.0;" & _
                    "Data Source=" & Server.MapPath("ExcelImport.xls") & ";" & _
                    "Extended Properties=Excel 8.0;"

        ' create your excel connection object using the connection string
        Dim objXConn As New OleDbConnection(xConnStr)
        objXConn.Open()

        ' use a SQL Select command to retrieve the data from the Excel Spreadsheet
        ' the "table name" is the name of the worksheet within the spreadsheet
        ' in this case, the worksheet name is "Members" and is coded as: [Members$]
        Dim objCommand As New OleDbCommand("SELECT * FROM [Members$]", objXConn)
        Return objCommand

    End Function

    Protected Sub ButtonView_Click(ByVal sender As Object, ByVal e As System.EventArgs) _
        Handles ButtonView.Click
        PanelUpload.Visible = False
        PanelView.Visible = True
        PanelImport.Visible = False

        ' Create a new Adapter
        Dim objDataAdapter As New OleDbDataAdapter()

        ' retrieve the Select command for the Spreadsheet
        objDataAdapter.SelectCommand = ExcelConnection()

        ' Create a DataSet
        Dim objDataSet As New DataSet()
        ' Populate the DataSet with the spreadsheet worksheet data
        objDataAdapter.Fill(objDataSet)

        ' Bind the data to the GridView
        GridViewExcel.DataSource = objDataSet.Tables(0).DefaultView
        GridViewExcel.DataBind()

    End Sub


    Protected Sub ButtonImport_Click(ByVal sender As Object, ByVal e As System.EventArgs) _
        Handles ButtonImport.Click
        PanelUpload.Visible = False
        PanelView.Visible = False
        PanelImport.Visible = True
        LabelImport.Text = String.empty ' reset to blank

        ' retrieve the Select Command for the worksheet data
        Dim objCommand As New OleDbCommand()
        objCommand = ExcelConnection()

        '  create a DataReader
        Dim reader As OleDbDataReader
        reader = objCommand.ExecuteReader()


        '  create variables for the spreadsheet columns
        Dim member_id As Integer = 0
        Dim category_id As Integer = 0
        Dim lastname As String = String.empty
        Dim firstname As String = String.empty
        Dim address1 As String = String.empty
        Dim address2 As String = String.empty
        Dim city As String = String.empty
        Dim state As String = String.empty
        Dim zip As String = String.empty
        Dim phone As String = String.empty
        Dim fax As String = String.empty
        Dim email As String = String.empty
        Dim website As String = String.Empty
        Dim category As String = String.Empty


        Dim counter As Integer = 0 ' used for testing your import in smaller increments

        While reader.Read()
            counter = counter + 1 ' counter to exit early for testing...

            ' set default values for loop
            member_id = 0
            category_id = 0

            lastname = Convert.ToString(reader("lastname"))
            firstname = Convert.ToString(reader("firstname"))
            address1 = Convert.ToString(reader("address1"))
            address2 = Convert.ToString(reader("address2"))

            city = Convert.ToString(reader("city"))
            state = Convert.ToString(reader("state"))
            zip = Convert.ToString(reader("zip"))
            phone = Convert.ToString(reader("phone"))

            fax = Convert.ToString(reader("fax"))
            email = Convert.ToString(reader("email"))
            ' Notice the space in the "web site" column from the Excel Spreadsheet
            website = Convert.ToString(reader("web site"))
            category = Convert.ToString(reader("category"))

            ' Insert any required validations here...

            category_id = GetCategoryID(category) 'retrieve the category_id
            member_id = ImportIntoMembers(lastname, firstname, address1, address2, city, state, zip, phone, fax, email, website, category_id)

            LabelImport.Text = LabelImport.Text & member_id & lastname & _
            " " & firstname & " " & address1 & " " & address2 & _
                " " & city & " " & state & " " & zip & " " & _
                phone & " " & fax & " " & email & " " & website & _
                " cat_id: " & category_id & " " & category & "<br>"
            'If counter > 2 Then ' exit early for testing, comment later...
            '    Exit While
            'End If

        End While
        reader.Close()

    End Sub


    Protected Sub ButtonUploadFile_Click(ByVal sender As Object, ByVal e As System.EventArgs) _
        Handles ButtonUploadFile.Click

        If FileUploadExcel.HasFile Then
            Try
                ' alter path for your project
                FileUploadExcel.SaveAs(Server.MapPath("~/ExcelImport.xls"))

                LabelUpload.Text = "Upload File Name: " & _
                     FileUploadExcel.PostedFile.FileName & "<br>" & _
                     "Type: " & _
                     FileUploadExcel.PostedFile.ContentType & _
                     " File Size: " & _
                     FileUploadExcel.PostedFile.ContentLength & " kb<br>"
            Catch ex As Exception
                LabelUpload.Text = "Error: " & ex.Message.ToString
            End Try
        Else
            LabelUpload.Text = "Please select a file to upload."
        End If

    End Sub



    Protected Function GetCategoryID(ByVal categoryname As String) As Integer

        Dim category_id As Integer = 0
        Try
            Dim SSAdapter As New SSSMembersDataSetTableAdapters.CategoryTableAdapter
            Dim SSDataTable As SSSMembersDataSet.CategoryDataTable = Nothing
            SSDataTable = SSAdapter.GetCategoryByName(categoryname)
            ' see if the category already exists in the table, if not insert it
            If Not SSDataTable Is Nothing Then
                If SSDataTable.Rows.Count > 0 Then
                    If Not SSDataTable(0).category_id = Nothing Then
                        category_id = SSDataTable(0).category_id
                    End If
                End If
            End If
            If category_id = 0 Then ' if it is still 0, then insert it into the table
                ' retrieve the identity key category_id from the insert
                category_id = _
                    Convert.ToInt32(SSAdapter.InsertCategoryQuery(categoryname))
                ' if this fails to return the proper category_id, make sure to 
                ' set the InsertCategoryQuery ExecuteMode Property to Scalar
            End If
            Return category_id
        Catch ex As Exception
            LabelImport.Text = LabelImport.Text & ex.ToString
            Return 0
        End Try

    End Function

    Protected Function ImportIntoMembers(ByVal lastname As String, ByVal firstname As String, ByVal address1 As String, _
                                    ByVal address2 As String, ByVal city As String, ByVal state As String, _
                                    ByVal zip As String, ByVal phone As String, ByVal fax As String, _
                                    ByVal email As String, ByVal website As String, ByVal category_id As Integer) As Integer


        ' make sure values don't exceed column limits
        lastname = Left(lastname, 50)
        firstname = Left(firstname, 50)
        address1 = Left(address1, 50)
        address2 = Left(address2, 50)
        city = Left(city, 50)
        state = Left(state, 2)
        zip = Left(zip, 10)
        phone = Left(phone, 12)
        fax = Left(fax, 12)
        email = Left(email, 50)
        website = Left(website, 200)

        Dim member_id As Integer = 0
        Try
            Dim SSAdapter As New SSSMembersDataSetTableAdapters.MembersTableAdapter
            Dim SSDataTable As SSSMembersDataSet.MembersDataTable = Nothing
            SSDataTable = SSAdapter.GetMemberByNameAddress(firstname, lastname, address1)
            ' see if the category already exists in the table, if not insert it
            If Not SSDataTable Is Nothing Then
                If SSDataTable.Rows.Count > 0 Then
                    If Not SSDataTable(0).member_id = Nothing Then
                        member_id = SSDataTable(0).member_id
                        LabelImport.Text = LabelImport.Text & _
                            "<font color=blue>Member Found, Not Imported: " & " ID: " & member_id & " " & lastname & " " & firstname & " address: " & address1 & ".</font><br>"
                    End If
                End If
            End If
            If member_id = 0 Then ' if it is still 0, then insert it into the table
                ' retrieve the identity key member_id from the insert
                member_id = _
                    Convert.ToInt32(SSAdapter.InsertMemberQuery(lastname, firstname, _
                        address1, address2, city, state, zip, phone, fax, _
                        email, website, category_id))
                LabelImport.Text = LabelImport.Text & _
                    "<font color=green>Member Imported: " & " ID: " & member_id & " " & lastname & " " & firstname & " address: " & address1 & ".</font><br>"
            End If
            Return member_id
        Catch ex As Exception
            LabelImport.Text = LabelImport.Text & "<font color=red>" & ex.ToString & "</font><br>"
            Return 0
        End Try

    End Function


End Class
